
local Currency = {} 
local frame=CreateFrame("frame",nil,Playerframe)
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("VARIABLES_LOADED")

frame:SetScript("OnEvent",function(self,event)
	--if event == "PLAYER_ENTERING_WORLD" then
		--Currency:Initialize()
	--end
    if event == "VARIABLES_LOADED" then
        Currency:Initialize()
        Currency:MinimapUpdatePosition()
    end
end)
function Currencyhandler(msg) 
ChatFrame1:AddMessage(msg)
      -- the empty string Treat as if Toggle
      if msg=="" then
		msg="toggle"
	  end
      if ( msg == "help" or msg=="?") then -- Display help
        ChatFrame1:AddMessage("type \"/curency on\" to turn on the currency icon for the minimap")
		ChatFrame1:AddMessage("type \"/curency off\" to turn off the currency icon for the minimap")
		ChatFrame1:AddMessage("type \"/curency\" to show toggle the state of the Currency MiniMap Icon")
	   end
if msg=="on" then 
	currencyminimap.Hidden=false
	currencyminimap.Button:Show()
	
end
if msg=="off" then 
	currencyminimap.Button:Hide()
	currencyminimap.Hidden=true
end
if msg=="toggle" then
	local hide=false
	if currencyminimap.Hidden==true then
		currencyminimap.Button:Show()
		hide=false
	end
	if currencyminimap.Hidden==false then
		currencyminimap.Button:Hide()
		hide=true
	end
	currencyminimap.Hidden=hide
end
end

MainMenuBarBackpackButton:HookScript("OnEnter", function(self)
     local currencystring=""
     local name, isHeader, isExpanded, isUnused, isWatched, count, icon, maximum, hasWeeklyLimit, currentWeeklyAmount, unknown;
   cCount = GetCurrencyListSize();
		local cu = GetMoney();
		currencystring=GetCoinTextureString(cu,"12")
		GameTooltip:SetPoint("BOTTOMLEFT", self, "TOP")
		GameTooltip:AddLine(" ")
		GameTooltip:AddLine("****************************",.0,1,.1)
		GameTooltip:AddLine(" ")
		GameTooltip:AddLine("Currency")
		GameTooltip:AddLine(currencystring,250,125,50)
   for index=1, cCount do 
      name, isHeader, isExpanded, isUnused, isWatched, count, icon, maximum, hasWeeklyLimit, currentWeeklyAmount, unknown = GetCurrencyListInfo(index)
      if (count~=0) then
            if icon~=nil then
            GameTooltip:AddDoubleLine(name, count.." |T"..icon..":16|t",1,1,1,1,1,1)
            end
      end      
      myindex=index
   end
		-- Add instructions to turn on icon if icon is off
		if currencyminimap.Hidden then
			GameTooltip:AddLine("\nType \"/currency\" to toggle the state\nof the Currency icon on the minimap",1,0,.5)
		end
		GameTooltip:Show()
end)



function Currency:Initialize()
SLASH_TRACKCURRENCY1 = "/currency"
SlashCmdList["TRACKCURRENCY"] = Currencyhandler
	if not currencyminimap then
		currencyminimap = {
			dragable = true,
			angle = 222,
			radius = 80,
			rounding = 10,
			Hidden = false
		}
	end
	-- MinimapFrame
	local f = CreateFrame("Frame", "Currency".."Minimap", Minimap)
	f:SetFrameStrata("LOW")
	f:SetWidth(33)
	f:SetHeight(33)
	f:SetPoint("CENTER")
	f:EnableMouse(true)

	self.Minimap = f
	
	-- Minimap
	local b = CreateFrame("Button", nil, f)
	b:SetAllPoints(f)
	b:SetHighlightTexture("Interface\\Minimap\\UI-MoneyButton-Hilight")
	    if currencyminimap.Hidden then
            b:Hide()
        else
            b:Show()
        end

	-- MinimapIcon
	local t = b:CreateTexture(nil, "BACKGROUND")
	t:SetWidth(20)
	t:SetHeight(20)
	t:SetPoint("CENTER")
	MinimapIconTexture = t
	t:SetTexture("Interface\\MoneyFrame\\UI-GoldIcon")
	
	-- MinimapBorder
	t = b:CreateTexture(nil, "OVERLAY")
	t:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
	t:SetWidth(52)
	t:SetHeight(52)
	t:SetPoint("TOPLEFT")
	
	-- set some scripts
		b:SetScript("OnClick", function(self,event)
			message("Type \"/currency\" to toggle the state of the Currency icon")
		end)
	b:SetScript("OnDragStart", function(self,event)
			if(currencyminimap.dragable) then
				self.dragme = true
				self:LockHighlight()
			end
		end)

	b:SetScript("OnDragStop", function(self,event)
			self.dragme = false
			self:UnlockHighlight()
		end)
	b:SetScript("OnUpdate", function(self,event)
			if(self.dragme == true) then
				Currency:MinimapBeingDragged()
			end
		end)
	b:SetScript("OnEnter", function(self,event)
        local name, isHeader, isExpanded, isUnused, isWatched, count, icon, maximum, hasWeeklyLimit, currentWeeklyAmount, unknown;
		local currencystring=""
		local cu = GetMoney();
		currencystring=GetCoinTextureString(cu,"12")
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:SetPoint("TOPRIGHT", self, "BOTTOM")
		GameTooltip:SetText("Currency")
		GameTooltip:AddLine(currencystring,250,125,50)
        cCount = GetCurrencyListSize();
    for index=1, cCount do 
      name, isHeader, isExpanded, isUnused, isWatched, count, icon, maximum, hasWeeklyLimit, currentWeeklyAmount, unknown = GetCurrencyListInfo(index)
      if (count~=0) then
            if icon~=nil then
            GameTooltip:AddDoubleLine(name, count.." |T"..icon..":16|t",1,1,1,1,1,1)
            end
      end
      myindex=index
    end
		GameTooltip:AddLine("\nType \"/currency\" to toggle the state\nof the Currency icon on the minimap",1,0,.5)

		GameTooltip:Show()
	end)
	b:SetScript("OnLeave", function(self,event)
			GameTooltip:Hide()
		end)

	
	-- init dragging
	b:RegisterForDrag("LeftButton")
	b.dragme = false
	-- Init Clicks
	b:RegisterForClicks("RightButtonUp")

	
	-- update the position of the button
	Currency:MinimapUpdatePosition()
	currencyminimap.Button=b
end


function Currency:SetMinimapPosition(angle, radius, rounding)
	currencyminimap.angle = angle
	if(radius) then
		currencyminimap.radius = radius
	end
	if(rounding) then
		currencyminimap.rounding = rounding
	end
	Currency:MinimapUpdatePosition()
	
end

function Currency:MinimapBeingDragged()
	local mx, my = Minimap:GetCenter()
	local mz = MinimapCluster:GetScale()
	local cx, cy = GetCursorPosition(UIParent)
	local cz = UIParent:GetEffectiveScale()
	local v = math.deg(math.atan2(cy / cz - my * mz, cx / cz - mx * mz))
	if v < 0 then
		v = v + 360
	elseif v > 360 then
		v = v - 360
	end
	Currency:SetMinimapPosition(v)
end

local MinimapShapes = {
	-- quadrant booleans (same order as SetTexCoord)
	-- {upper-left, lower-left, upper-right, lower-right}
	-- true = rounded, false = squared
	["ROUND"] 								= {true, true, true, true},
	["SQUARE"] 								= {false, false, false, false},
	["CORNER-TOPLEFT"] 				= {true, false, false, false},
	["CORNER-TOPRIGHT"] 			= {false, false, true, false},
	["CORNER-BOTTOMLEFT"] 		= {false, true, false, false},
	["CORNER-BOTTOMRIGHT"]	 	= {false, false, false, true},
	["SIDE-LEFT"] 						= {true, true, false, false},
	["SIDE-RIGHT"] 						= {false, false, true, true},
	["SIDE-TOP"] 							= {true, false, true, false},
	["SIDE-BOTTOM"] 					= {false, true, false, true},
	["TRICORNER-TOPLEFT"] 		= {true, true, true, false},
	["TRICORNER-TOPRIGHT"] 		= {true, false, true, true},
	["TRICORNER-BOTTOMLEFT"] 	= {true, true, false, true},
	["TRICORNER-BOTTOMRIGHT"] = {false, true, true, true},
	}
function Currency:MinimapUpdatePosition()
	local radius, rounding, angle
	
	radius = currencyminimap.radius
	rounding = currencyminimap.rounding
	angle = math.rad(currencyminimap.angle)
	
	local x = math.cos(angle)
	local y = math.sin(angle)
	local q = 1;
	if x < 0 then
		q = q + 1;	-- lower
	end
	if y > 0 then
		q = q + 2;	-- right
	end
	local minimapShape = GetMinimapShape and GetMinimapShape() or "ROUND"
	local quadTable = MinimapShapes[minimapShape]
	if quadTable[q] then
		x = x*radius
		y = y*radius
	else
		local diagRadius = math.sqrt(2*(radius)^2)-rounding
		x = math.max(-radius, math.min(x*diagRadius, radius))
		y = math.max(-radius, math.min(y*diagRadius, radius))
	end
	Currency.Minimap:SetPoint("CENTER", Minimap, "CENTER", x, y-1)
    if Currency.Minimap.Button then
        Currency.Minimap.Button:Show()
    end
end